# =====================================================================
# login.awk: RPC I/O functions for example.calendar
# Copyright (c) 2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or   
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License   
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================

# =====================================================================
# int _invar(string name, string value)
#
# Input hooks *must* always write rc(1) statements to CSA_RPC_WWW.
# =====================================================================

function _invar(name,value,		ofile, pw_len, nick) {

   # Make local copies, especially of those vars that we
   # will need to modify.

   ofile = ENVIRON["CSA_RPC_WWW"]

   # Check for valid month.

   if (name == "WWW_2" || name == "WWW_month") {
      value /= 1				# Casting is mandatory!
      if (value < 1 || value > 12)
		print "csaExit.fault 0041 month" >> ofile
      else return(_rcassign(name,value,ofile))
   }

   # Check for valid year.

   else if (name == "WWW_1" || name == "WWW_year") {
      value /= 1				# Casting is mandatory!
      if (value < 1 || value > 9999)
		print "csaExit.fault 0041 year" >> ofile
      else return(_rcassign(name,value,ofile))
   }

   return 0				# Ignore unknown arguments.
}

# =====================================================================
# string _outvar(string name, string value)
#
# Default output variable post-processing hook. Simply returns the
# passed argument value unchanged.
# =====================================================================

function _outvar(name,value) {

   return value
}

# EOF
