# =====================================================================
#  htmltpl.awk: shell front-end to the envtohtml() AWK function.
#
#  Copyright (c) 2002,2003 Carlo Strozzi
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: htmltpl.awk,v 1.4 2003/04/28 20:33:19 carlo Exp $

BEGIN {

  # Set default args before calling envtohtml(). I use the same
  # names here for clarity, but it is not necessary, of course,
  # as everything is localised by the function.

  if (tpl == "") tpl = "/dev/null"
  if (tbl !~ /^\//) tbl = ""		# Accept only full-path spec.
  if (froot == "") froot = ENVIRON["CSA_ROOT"] "/html/"
  if (trim != 1) trim = 0
  if (tago == "") tago = "$["
  if (tagc == "") tagc = "]"
  if (tago == tagc) exit(1)	# start- and end-tags must be different
  if (ofile == "") ofile = STDOUT

  usf = ENVIRON["CSA_ROOT"] "/var/user.d/" \
	ENVIRON["CSA_USER_PBC"] "/" ENVIRON["REMOTE_USER"]

  if ((rc = envtohtml(tpl,froot,eval,tbl,trim,tago,tagc,ofile))) exit(rc)

  # Test whether this is an authenticated user session
  # and save the current state in the USF if it is.

  if (ENVIRON["REMOTE_USER"] != "" && \
	ENVIRON["CSA_USER_ID"] != "" && \
	ENVIRON["CSA_USER_PBC"] ~ /^.\/.$/ && \
	ENVIRON["CSA_USF_CACHE"] != "") {

     # Create USF.
     if ((rc = creat(usf, O_TRUNC))) exit(rc)

     # Write selected status data to USF.
     for (env in ENVIRON) {
	 if (env ~ ENVIRON["CSA_USF_CACHE"])
	 	rcassign(env, ENVIRON[env], usf)
     }

     # Write new time-stamp to USF.
     rcassign("CSA_USF_TIME", ENVIRON["CSA_TIME_ISO"], usf)
  }
}

# EOF
